#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

#define FDO 1

void wrblk(unsigned char *p, unsigned char tam, unsigned char tipo)
{
	unsigned char ck;
	int i,tama;
	
	tama=tam;
	write(FDO,&tipo,1);
	tam++; tam++;
	write(FDO,&tam,1);
	ck=0;
	for (i=0;i<tama;i++) ck+=p[i];
	ck=~ck; ck++;
	write(FDO,p,tama);
	write(FDO,&ck,1);
}

main (int argc, char **argv)
{

	int i,ini,tam,fdi;
	unsigned char buf[257];

	if (argc<3) {
		fprintf(stderr,"Usage: bin2k7 file start\n");
		exit(0);
	}

	if (strstr(argv[2],"0x")!=NULL || strstr(argv[2],"0X")!=NULL)
		sscanf(argv[2],"%x",&ini);
	else 	ini=atoi(argv[2]);


	if ((fdi=open(argv[1],O_RDONLY))==-1) exit(0);

	tam=lseek(fdi,0,SEEK_END);
	lseek(fdi,0,SEEK_SET);

	fprintf(stderr,"File: %s Start: 0x%04X Len:  0x%04X\n",argv[1],ini,tam);

	strcpy(buf,"IMAGE   BIN");
	buf[11]=2; buf[12]=0; buf[13]=0;

	wrblk(buf,14,0);

	buf[0]=0;	/* Fichero binario */
	buf[1]=tam>>8;	/* Tamao total del fichero */
	buf[2]=tam&0xff;
	buf[3]=ini>>8;	/* Direccin inicial */
	buf[4]=ini&0xff;
	i=read(fdi,buf+5,249);
	wrblk(buf, i+5, 1);	/* Primer bloque */
	tam-=i;
	fprintf(stderr,"."); fflush(stderr);

	do {
		if (tam>254) i=read(fdi,buf,254); else i=read(fdi,buf,tam);
		if (!i) break;
		wrblk(buf, i, 1);
		tam-=i;
		fprintf(stderr,"."); fflush(stderr);
	}while (tam>0);

	buf[0]=0x02;	/* Final de fichero binario: post-data :)*/
	buf[1]=ini>>8;  /* Direccin inicial */
	buf[2]=ini&0xff;
	buf[3]=ini>>8;  /* Direccin inicial */
	buf[4]=ini&0xff;

	wrblk(buf, 5, 1);

	wrblk(buf, 0, 0xff);	/* Marca de final */
	fprintf(stderr,"\n\n");

	close(fdi);
}
