#include <stdio.h>
#include <fcntl.h>

#define NB 0x40000
unsigned char ibuf[NB];

main(int argc, char **argv)
{
    unsigned char *p,ty;
    unsigned int i,n,m,nb,cb,tnb;
    int fd;

    if (argc<3) {
        printf("Usage: %s file_in.k7 file_out.k7s\n",argv[0]);
        exit(0);
    }
    // Reading input file to memory
    if ((fd=open(argv[1],O_RDONLY))==-1) {perror("open"); exit(1);}
    n=read(fd,ibuf,NB);
    close(fd);
    printf("Input: %s (%d bytes)\n",argv[1],n);
    // Opening output file
    if ((fd=creat(argv[2],0666))==-1) {perror("creat"); exit(1);}

    p=ibuf; cb=tnb=0;
    for (;;) {
        m=0;
        // wait for a mark
        do {
            m<<=8; m+=*p++; m&=0xffffff;
            if (p>&ibuf[n]) {
                close(fd);
                printf("\nOutput file: %s\n",argv[2]);
                printf("Total: %d blocks, %d bytes\n",cb,tnb);
                exit(0);
            }
        }while (m!=0x013c5a);
        cb++;
        ty=*p;                          // Block type
        nb=p[1]; if (!nb) nb=256;       // Block lenght
        // write block
        write(fd,p,nb+1);
        printf(" %02X.%03X ",ty,nb); fflush(stdout);
        // advance to the end of currect block
        p=&p[nb+1];
        tnb+=nb+1;
    }
}

